#!/usr/bin/lua
-- Lua code to interact with the Agms Gateway

-- @author: Maanas Royy
-- @copyright: Avant-Garde Marketing Solutions, Inc.

-- Define package path to load libraries
package.path = './lib/luasoap-3.0/src/?.lua;' .. package.path		-- luasoap
package.path = './lib/luaexpat-1.3.0/src/?.lua;' .. package.path	-- luaexpat
package.path = '/usr/local/share/lua/5.1/?.lua;' .. package.path	-- luasocket
package.path = './lib/luasec-0.4.1/src/?.lua;' .. package.path		-- luasec

-- Define package path to load C libraries
package.cpath = './lib/luaexpat-1.3.0/src/?.so;' .. package.cpath	-- luaexpat
package.cpath = '/usr/local/lib/lua/5.1/?.so;' .. package.cpath		-- luasocket
package.cpath = './lib/luasec-0.4.1/src/?.so;' .. package.cpath		-- luasec

-- Import agms 
local agms = require "agms"
-- Import helper function to print lua table
local print_r = require "helper"

-- Import LuaSoap
agms.soap_client = require "client"
-- Import SSL, Version 0.4 require you to call https before we can actually load ssl.https.
-- It exports module as ssl.https
require "https"
local https = require "ssl.https"

-- Assign the https protocol in SOAP client
agms.soap_client.https = https

-- Prepare Request
agms.Request.GatewayUserName = "#########";
agms.Request.GatewayPassword = "#########";
agms.Request.TransactionType = "sale";
agms.Request.PaymentType = "creditcard";
agms.Request.Amount = "1.00";
agms.Request.CCNumber = "4111111111111111";
agms.Request.CCExpDate = "0120";
agms.Request.CVV = "123";

-- Debug request
-- print_r(agms.Request)

local ns, meth, ent = agms.AgmsAPI.ProcessTransaction(agms.Request);
print("namespace = ", ns, "element name = ", meth)
for i, elem in ipairs (ent[1]) do
	print (elem['tag'], '=', elem[1])
end

